/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookLeadsConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookLeadsConnectorForm{}

// FacebookLeadsConnectorForm struct for FacebookLeadsConnectorForm
type FacebookLeadsConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// OAuthId
	OAuthId string `json:"oAuthId"`
	// Data source label
	Label string `json:"label"`
	// Facebook page identifier
	PageId string `json:"pageId"`
	// Facebook form identifier
	FormId string `json:"formId"`
	// Facebook Leads attributes
	Attribute []string `json:"attribute"`
	// Limit of post to be asked
	Limit int32 `json:"limit"`
	// Date range.
	DateRange string `json:"dateRange"`
}

// NewFacebookLeadsConnectorForm instantiates a new FacebookLeadsConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookLeadsConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, pageId string, formId string, attribute []string, limit int32, dateRange string) *FacebookLeadsConnectorForm {
	this := FacebookLeadsConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.PageId = pageId
	this.FormId = formId
	this.Attribute = attribute
	this.Limit = limit
	this.DateRange = dateRange
	return &this
}

// NewFacebookLeadsConnectorFormWithDefaults instantiates a new FacebookLeadsConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookLeadsConnectorFormWithDefaults() *FacebookLeadsConnectorForm {
	this := FacebookLeadsConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *FacebookLeadsConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *FacebookLeadsConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *FacebookLeadsConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *FacebookLeadsConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *FacebookLeadsConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *FacebookLeadsConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *FacebookLeadsConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *FacebookLeadsConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *FacebookLeadsConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *FacebookLeadsConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *FacebookLeadsConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *FacebookLeadsConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *FacebookLeadsConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetPageId returns the PageId field value
func (o *FacebookLeadsConnectorForm) GetPageId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PageId
}

// GetPageIdOk returns a tuple with the PageId field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetPageIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PageId, true
}

// SetPageId sets field value
func (o *FacebookLeadsConnectorForm) SetPageId(v string) {
	o.PageId = v
}

// GetFormId returns the FormId field value
func (o *FacebookLeadsConnectorForm) GetFormId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.FormId
}

// GetFormIdOk returns a tuple with the FormId field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetFormIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.FormId, true
}

// SetFormId sets field value
func (o *FacebookLeadsConnectorForm) SetFormId(v string) {
	o.FormId = v
}

// GetAttribute returns the Attribute field value
func (o *FacebookLeadsConnectorForm) GetAttribute() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetAttributeOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Attribute, true
}

// SetAttribute sets field value
func (o *FacebookLeadsConnectorForm) SetAttribute(v []string) {
	o.Attribute = v
}

// GetLimit returns the Limit field value
func (o *FacebookLeadsConnectorForm) GetLimit() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Limit
}

// GetLimitOk returns a tuple with the Limit field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetLimitOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Limit, true
}

// SetLimit sets field value
func (o *FacebookLeadsConnectorForm) SetLimit(v int32) {
	o.Limit = v
}

// GetDateRange returns the DateRange field value
func (o *FacebookLeadsConnectorForm) GetDateRange() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DateRange, true
}

// SetDateRange sets field value
func (o *FacebookLeadsConnectorForm) SetDateRange(v string) {
	o.DateRange = v
}

func (o FacebookLeadsConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookLeadsConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["pageId"] = o.PageId
	toSerialize["formId"] = o.FormId
	toSerialize["attribute"] = o.Attribute
	toSerialize["limit"] = o.Limit
	toSerialize["dateRange"] = o.DateRange
	return toSerialize, nil
}

type NullableFacebookLeadsConnectorForm struct {
	value *FacebookLeadsConnectorForm
	isSet bool
}

func (v NullableFacebookLeadsConnectorForm) Get() *FacebookLeadsConnectorForm {
	return v.value
}

func (v *NullableFacebookLeadsConnectorForm) Set(val *FacebookLeadsConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookLeadsConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookLeadsConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookLeadsConnectorForm(val *FacebookLeadsConnectorForm) *NullableFacebookLeadsConnectorForm {
	return &NullableFacebookLeadsConnectorForm{value: val, isSet: true}
}

func (v NullableFacebookLeadsConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookLeadsConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
